/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ulozka1;

import java.awt.AWTEvent;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.AWTEventListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author ucebna
 */
public class MainFrame extends javax.swing.JFrame {
    JFrame instance = this;
    BufferedImage[][] dilyMapy = new BufferedImage[5][5];
    private String prevUlr;
    private int prevZ;
    int pixel_x = 1000;
    int pixel_y = 0;
    boolean kresli = false;

    int prvni_v_poli_x = 0;
     int prvni_v_poli_y = 0;
    Point start_posun = new Point();
    Point puvodni_odsun = new Point();
    /**
     * Creates new form MainFrame
     */
    public MainFrame() {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (InstantiationException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedLookAndFeelException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
        initComponents();
        new NacitaniMapy(0,0).start();
        prevUlr = txf_url.getText();
        prevZ = slider_z.getValue();
        slider_x.setMinimum(0);
        slider_y.setMinimum(0);
        int mocnina = (int) Math.pow(2, slider_z.getValue());
        slider_x.setMaximum((int) (3 * mocnina));
        slider_x.setMajorTickSpacing(slider_x.getMaximum() / 2);
        slider_x.setMinorTickSpacing(1);
        slider_y.setMaximum((int) (2 * mocnina));
        slider_y.setMajorTickSpacing(slider_x.getMaximum() / 2);
        slider_y.setMinorTickSpacing(1);
     
        this.pack();
        
        slider_z.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent ce) {
                int mocnina = (int) Math.pow(2, slider_z.getValue());
                slider_x.setMaximum((int) (3 * mocnina));
                slider_y.setMaximum((int) (2 * mocnina));
                slider_y.setMajorTickSpacing(slider_x.getMaximum() / 10);
                slider_x.setMajorTickSpacing(slider_x.getMaximum() / 10);
                if(prevZ > slider_z.getValue()){
                    pixel_x *= 2;
                    pixel_y*=2;
                     pixel_x += 256;
                     pixel_y += 256;
                }else{
                      pixel_x/=2;
                  pixel_y/=2;
                }
                 new NacitaniMapy(pixel_x/256,pixel_y/256).start();
            }
        });
         slider_x.addChangeListener(new ChangeListener() {

            @Override
            public void stateChanged(ChangeEvent ce) {
                pixel_x = 256*slider_x.getValue();
                instance.invalidate();
            }
        });
         slider_y.addChangeListener(new ChangeListener() {

            @Override
            public void stateChanged(ChangeEvent ce) {
                pixel_y = 256*slider_y.getValue();
                instance.invalidate();
            }
        });
        
        mapa_panel.addMouseListener(new MouseAdapter() {

            @Override
            public void mousePressed(MouseEvent me) {
                start_posun = me.getPoint();
                puvodni_odsun.x = pixel_x;
                puvodni_odsun.y = pixel_y;
            }
        });
        
        mapa_panel.addMouseMotionListener(new MouseMotionAdapter() {
            @Override
            public void mouseDragged(MouseEvent me) {
                pixel_x =  start_posun.x - me.getPoint().x + puvodni_odsun.x;
                pixel_y =  start_posun.y - me.getPoint().y + puvodni_odsun.y;
                mapa_panel.repaint();
                instance.invalidate();
            }
        });
        
        Toolkit.getDefaultToolkit().addAWTEventListener(new AWTEventListener() {
            long minule_plus = 0;
            long minule_minus= 0;
            @Override
            public void eventDispatched(AWTEvent awte) {
                // zvýšení přiblížení pomocí klávesi +
                if(((KeyEvent)awte).getKeyChar() == '+'){
                    if(minule_plus + 1000 < ((KeyEvent)awte).getWhen() && slider_z.getValue()+1 <= slider_z.getMaximum()){
                        slider_z.setValue(slider_z.getValue()+1);
                        slider_z.validate();
                        minule_plus = ((KeyEvent)awte).getWhen();
                    }
                }else
                    // oddálení pomocí -
                if(((KeyEvent)awte).getKeyChar() == '-'){
                   if(minule_minus + 1000 < ((KeyEvent)awte).getWhen() && slider_z.getValue()-1 >= slider_z.getMinimum()){
                    slider_z.setValue(slider_z.getValue()-1);
                    slider_z.validate();
                    minule_minus = ((KeyEvent)awte).getWhen();
                   }
                }else{
                    minule_minus = 0;
                    minule_plus = 0;
                }
            }
        },AWTEvent.KEY_EVENT_MASK );
        kresli = true;
    }

    private boolean isCislo(JTextField a) {
        try {
            Integer.parseInt(a.getText());
            a.setBackground(Color.white);
            return true;
        } catch (java.lang.NumberFormatException e) {
            a.setBackground(Color.red);
            return false;
        }
    }

    private int getCislo(JTextField a) {
        return Integer.parseInt(a.getText());
    }

    Point souradnice_stred = new Point();
    private void kresliMapu(Graphics g) {
        if (!kresli) {
            return;
        }
        // ohlídání hranic
        if(pixel_x < 0)
            pixel_x = 0;
        if(pixel_y < 0)
            pixel_y = 0;
        if(pixel_x > slider_x.getMaximum() * 256){
            pixel_x = slider_x.getMaximum() * 256- 3 *256;
        }
        if(pixel_y > slider_y.getMaximum() * 256){
            pixel_y = slider_y.getMaximum() * 256- 2 * 256;
        }
     
        int prvni_x = pixel_x / 256;
        int prvni_y = pixel_y / 256;
        
        // spočtení odsazení prvního čtverce
        int odsazeni_x = pixel_x%256;
        int odsazeni_y = pixel_y%256;
        // vykreslení
        try{
            for (int x = prvni_x; x < 4 + prvni_x; x++) {
               for (int y = prvni_y ; y < 3 + prvni_y; y++) {  
                   if(x <  prvni_v_poli_x + 4 && y < prvni_v_poli_y + 3 && x - prvni_v_poli_x >= 0 && y - prvni_v_poli_y >=0)
                    g.drawImage(dilyMapy[x-prvni_v_poli_x][y - prvni_v_poli_y], 256 * (x - prvni_x) - odsazeni_x, 256 * (y -prvni_y) - odsazeni_y, this);
                   else{
                       g.setColor(Color.WHITE);
                       g.fillRect(256 * (x - prvni_x) - odsazeni_x, 256 * (y -prvni_y) - odsazeni_y, 256, 256);
                       new NacitaniMapy(prvni_x, prvni_y).start();
                   }
                }
        }
        }catch(Exception e){
            System.out.println(prvni_v_poli_x);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        mapa_panel = new JPanel(){
            @Override
            public void paint(Graphics g){
                kresliMapu(g);
            }
        };
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txf_url = new javax.swing.JTextField();
        txf_port = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        slider_z = new javax.swing.JSlider();
        slider_y = new javax.swing.JSlider();
        slider_x = new javax.swing.JSlider();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setBackground(new java.awt.Color(255, 255, 255));

        jLabel1.setText("x");

        jLabel2.setText("y");

        mapa_panel.setBackground(new java.awt.Color(255, 255, 255));
        mapa_panel.setMaximumSize(new java.awt.Dimension(768, 768));
        mapa_panel.setMinimumSize(new java.awt.Dimension(768, 768));
        mapa_panel.setPreferredSize(new java.awt.Dimension(768, 768));

        javax.swing.GroupLayout mapa_panelLayout = new javax.swing.GroupLayout(mapa_panel);
        mapa_panel.setLayout(mapa_panelLayout);
        mapa_panelLayout.setHorizontalGroup(
            mapa_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        mapa_panelLayout.setVerticalGroup(
            mapa_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jLabel3.setText("url");

        jLabel4.setText("port");

        txf_url.setText("http://192.168.2.76");

        txf_port.setText("80");

        jLabel5.setText("z");

        slider_z.setMajorTickSpacing(1);
        slider_z.setMaximum(9);
        slider_z.setMinimum(0);
        slider_z.setOrientation(javax.swing.JSlider.VERTICAL);
        slider_z.setPaintLabels(true);
        slider_z.setPaintTicks(true);
        slider_z.setSnapToTicks(true);
        slider_z.setValue(1);

        slider_y.setOrientation(javax.swing.JSlider.VERTICAL);
        slider_y.setPaintLabels(true);
        slider_y.setPaintTicks(true);
        slider_y.setSnapToTicks(true);

        slider_x.setOrientation(javax.swing.JSlider.VERTICAL);
        slider_x.setPaintLabels(true);
        slider_x.setPaintTicks(true);
        slider_x.setSnapToTicks(true);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(txf_url, javax.swing.GroupLayout.PREFERRED_SIZE, 216, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txf_port, javax.swing.GroupLayout.PREFERRED_SIZE, 354, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(mapa_panel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 642, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(slider_x, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(slider_y, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(slider_z, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(57, 57, 57))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(txf_url, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel4)
                            .addComponent(txf_port, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(mapa_panel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(slider_z, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1)
                            .addComponent(slider_x, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(slider_y, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2)
                            .addComponent(jLabel5))
                        .addGap(0, 599, Short.MAX_VALUE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel mapa_panel;
    private javax.swing.JSlider slider_x;
    private javax.swing.JSlider slider_y;
    private javax.swing.JSlider slider_z;
    private javax.swing.JTextField txf_port;
    private javax.swing.JTextField txf_url;
    // End of variables declaration//GEN-END:variables

    class NacitaniMapy extends Thread {
        int x,y;
       public NacitaniMapy(int x, int y) {
            this.x = x;
            this.y = y;
         
        }
        
        @Override
        public void run() {
            String url = txf_url.getText();
            prevUlr = url;
            prevZ = slider_z.getValue();
            if (isCislo(txf_port)) {
                int port = getCislo(txf_port);
                for(int i = 0; i < dilyMapy.length && prevZ == slider_z.getValue();i++)
                    for(int j = 0; j < dilyMapy[i].length && prevZ == slider_z.getValue(); j++)
                try {
                    dilyMapy[i+x][j+y] = Komunikace.getKousekMapy(url, port, prevZ, i+x, j+y);
                } catch (Exception ex) {
                  
                }
            }
            mapa_panel.repaint();
               prvni_v_poli_x = x;
            prvni_v_poli_y = y;
        }
    }
}
